using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        //Optionally, you may want to do some stuff right after every mod is loaded
        public static void OnLoad()
        {
            UnityEngine.Debug.Log("Haha");
        }

        //Mods require one of these
        public static void Main()
        {
            CategoryBuilder.Create("AREA-51", "", ModAPI.LoadSprite("Thumb.png"));


            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Assault Rifle"), 
                    NameOverride = "AR-15", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("AR15.png", 1.6f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("AR15.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("glock.wav"),
                        };

                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), 
                    NameOverride = "Glock", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Glock.png", 1.6f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Glock.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("glock.wav"),
                        };                    
			        }
			    }
		    );                                           
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "AREA-51 Guard", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("Military.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("Military.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "NARUTO", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("naruto.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("naruto.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Alien", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("alien.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("alien.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Armor Guards", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Vest_Top.png"),
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 31;
                        prop.armorPoints = 100;
                        prop.sprite = ModAPI.LoadSprite("Vest_Top.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].armorTier = 31;
                        armProp[0].armorPoints = 100;
                        armProp[0].sprite = ModAPI.LoadSprite("Vest_Middle.png");


                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
          
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Helmet Guard", 
                    NameToOrderByOverride = "",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Helmet.png"),
                    AfterSpawn = (Instance) => 
                    {
                        int PartCount = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.03f;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 31;
                        prop.armorPoints = 100;
                        prop.sprite = ModAPI.LoadSprite("Helmet.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 2];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 2];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
 
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Alien Mask", 
                    NameToOrderByOverride = "",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("alien mask.png"),
                    AfterSpawn = (Instance) => 
                    {
                        int PartCount = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.03f;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.armorPoints = 10;
                        prop.sprite = ModAPI.LoadSprite("alien mask.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 2];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 2];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
 
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), 
                    NameOverride = "Poster-1", 
                    DescriptionOverride = "Poster", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Poster.png", 5f), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Poster.png");
                        Instance.FixColliders(); 
                    }
                }
            );                   
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"), 
                    NameOverride = "Poster-2", 
                    DescriptionOverride = "Poster", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("Poster2.png", 5f), 
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Poster2.png"); 
                        Instance.FixColliders();
                    }
                }
            );                   
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Alien", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("alien.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("alien.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );            
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Gray Alien", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("gray alien.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("gray alien.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Raider Pro", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("raider-pro.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("raider-pro.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Raider Noob", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("raider-noob.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("raider-noob.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
           ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Armor Raiders", 
                    NameToOrderByOverride = "!",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("vest_top_black.png"),
                    AfterSpawn = (Instance) => 
                    {
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.0f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.1f;

                        int PartCount = 3;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "UpperBody";
                        prop.armorTier = 31;
                        prop.armorPoints = 100;
                        prop.sprite = ModAPI.LoadSprite("vest_top_black.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 1];

                        armProp[0].armorPiece = "MiddleBody";
                        armProp[0].armorTier = 31;
                        armProp[0].armorPoints = 100;
                        armProp[0].sprite = ModAPI.LoadSprite("vest_middle_black.png");


                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 1];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
          
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Gray Alien Mask", 
                    NameToOrderByOverride = "",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("gray alien mask.png"),
                    AfterSpawn = (Instance) => 
                    {
                        int PartCount = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.03f;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.armorPoints = 10;
                        prop.sprite = ModAPI.LoadSprite("gray alien mask.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 2];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 2];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
 
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bulletproof Mask Raiders", 
                    NameToOrderByOverride = "",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("mask.png"),
                    AfterSpawn = (Instance) => 
                    {
                        int PartCount = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.03f;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 31;
                        prop.armorPoints = 100;
                        prop.sprite = ModAPI.LoadSprite("mask.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 2];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 2];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
 
                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Gas Mask", 
                    NameToOrderByOverride = "",
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("GasMask.png"),
                    AfterSpawn = (Instance) => 
                    {
                        int PartCount = 2;

                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.03f;
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.mass = 0.03f;

                        if (!Instance.GetComponent<ArmorBehaviour>())
                            Instance.AddComponent<ArmorBehaviour>();

                        ArmorBehaviour armor = Instance.GetComponent<ArmorBehaviour>();

                        ArmorProperties prop = new ArmorProperties();
                        
                        prop.armorPiece = "Head";
                        prop.armorTier = 1;
                        prop.armorPoints = 10;
                        prop.sprite = ModAPI.LoadSprite("GasMask.png");

                        armor.prop = prop;
                        armor.SetProperties();

                        ArmorProperties[] armProp = new ArmorProperties[PartCount - 2];

                        if (armor.spawn)
                        {
                            armor.SetPieces = new ArmorBehaviour[PartCount - 2];
                            armor.SpawnOtherParts(armProp);
                        }

                        Instance.FixColliders();
 
                    }
                }
            );                   
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pistol"), 
                    NameOverride = "Berreta", 
                    DescriptionOverride = "", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("berreta.png", 20f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("berreta.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("glock.wav"),
                        };                    
			        }
			    }
		    );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"), 
                    NameOverride = "Browning M2HB", 
                    DescriptionOverride = "TACTICAL GLOCK 0_0", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("m2hb.png", 20f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m2hb.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 3f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 2f; 
                        customCartridge.Recoil *= 2f; 
                        customCartridge.ImpactForce *= 1f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound(""),
                        };

                    }
                }
            );                    
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"), 
                    NameOverride = "M249", 
                    DescriptionOverride = "TACTICAL MACHINE GUN 0_0", 
                    CategoryOverride = ModAPI.FindCategory("AREA-51"), 
                    ThumbnailOverride = ModAPI.LoadSprite("m249.png", 60f), 
                    AfterSpawn = (Instance) => 
                    {

                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("m249.png");
                        Instance.FixColliders();

                        var firearm = Instance.GetComponent<FirearmBehaviour>();


                        Cartridge customCartridge = ModAPI.FindCartridge("9mm"); 
                        customCartridge.name = "9mm"; 
                        customCartridge.Damage *= 0.5f; 
                        customCartridge.StartSpeed *= 1.5f; 
                        customCartridge.PenetrationRandomAngleMultiplier *= 0.5f; 
                        customCartridge.Recoil *= 0.7f; 
                        customCartridge.ImpactForce *= 0.7f; 

                        firearm.Cartridge = customCartridge;


                        firearm.ShotSounds = new AudioClip[]
                        {
                            ModAPI.LoadSound("ar15.wav"),
                        };

                    }
                }
            );                    
            ModAPI.Register(
			    new Modification()
			    {
			        OriginalItem = ModAPI.FindSpawnable("Human"), 
			        NameOverride = "Reseacher", 
			        DescriptionOverride = "",
			        CategoryOverride = ModAPI.FindCategory("AREA-51"), 
			        ThumbnailOverride = ModAPI.LoadSprite("scienest.png"), 
			        AfterSpawn = (Instance) => 
			        {
			           
			            var skin = ModAPI.LoadTexture("scienest.png");
						
			            

			            
			            var person = Instance.GetComponent<PersonBehaviour>();

			            
			            person.SetBodyTextures(skin, null, null, 1);

			            
			            person.SetBruiseColor(82, 58, 58); 
			            person.SetSecondBruiseColor(107, 0, 5); 
			            person.SetThirdBruiseColor(150, 81, 81); 
			            person.SetRottenColour(112, 30, 30); 
			            person.SetBloodColour(108, 0, 4); 
                        foreach (var body in person.Limbs)
                        {
                             body.BaseStrength *= 1f;                          
                             body.Health *= 1f;
                             body.BreakingThreshold *= 2f;
                        }


			        }
			    }
		    );                    
                    } 
                }            
            } 